/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.awt.image.*;
import java.awt.*;
import java.io.*;
import java.applet.*;
import java.net.*;

public class StyleConst
{
	public String styleName;
	public String styleFolderName;
	public int bolderBig=3, bolderUp=2, bolderDown=3, bolderLED=1;
	public Image[] block=new Image[Constant.BLOCK];
	public Image[] face=new Image[Constant.FACE];
	public Image[] led=new Image[Constant.LED];
	private Image blocks, faces, leds;
	public Image icon, iconup, icondown;
	public boolean loaded=false;
	public boolean processed=false;

	public StyleConst(String name, String folderName)
	{
		this.styleName=name;
		this.styleFolderName=folderName;
	}

	public void getStyle()
	{
		if(loaded==true)
			return;
		MediaTracker aTracker;
		BufferedReader br=null;
		if(!Constant.isApplet)
		{
			Toolkit aKit=Toolkit.getDefaultToolkit();
			aTracker=new MediaTracker(Constant.topApplet);

			icon=aKit.getImage("image/"+styleFolderName+"/icon.gif");
			aTracker.addImage(icon,0);

			blocks=aKit.getImage("image/"+styleFolderName+"/block.gif");
			aTracker.addImage(blocks,0);

			faces=aKit.getImage("image/"+styleFolderName+"/face.gif");
			aTracker.addImage(faces,0);

			leds=aKit.getImage("image/"+styleFolderName+"/led.gif");
			aTracker.addImage(leds,0);
			try
			{
				File iniFile=new File("image/"+styleFolderName+"/style.ini");
				if(iniFile.exists() && iniFile.isFile() && iniFile.canRead())
				{
					br=new BufferedReader(new FileReader(iniFile));
				}
			}
			catch(IOException e){}
		}
		else
		{
			Applet app=Constant.topApplet;
			aTracker=new MediaTracker(Constant.topApplet);

			icon=app.getImage(app.getCodeBase(),"image/"+styleFolderName+"/icon.gif");
			aTracker.addImage(icon,0);

			iconup=app.getImage(app.getCodeBase(),"image/"+styleFolderName+"/iconup.gif");
			aTracker.addImage(iconup,0);

			icondown=app.getImage(app.getCodeBase(),"image/"+styleFolderName+"/icondown.gif");
			aTracker.addImage(icondown,0);

			blocks=app.getImage(app.getCodeBase(),"image/"+styleFolderName+"/block.gif");
			aTracker.addImage(blocks,0);

			faces=app.getImage(app.getCodeBase(),"image/"+styleFolderName+"/face.gif");
			aTracker.addImage(faces,0);

			leds=app.getImage(app.getCodeBase(),"image/"+styleFolderName+"/led.gif");
			aTracker.addImage(leds,0);

			try
			{
				URL styleURL=new
						URL(app.getCodeBase(), "image/"+styleFolderName+"/style.ini");
				br=new BufferedReader(new InputStreamReader(styleURL.openStream()));
			}
			catch(MalformedURLException e){}
			catch(IOException e){}
		}

		try
		{
			bolderBig=Integer.valueOf(br.readLine()).intValue();
			bolderUp=Integer.valueOf(br.readLine()).intValue();
			bolderDown=Integer.valueOf(br.readLine()).intValue();
			bolderLED=Integer.valueOf(br.readLine()).intValue();
			br.close();
		}
		catch(IOException e){}
		catch(NumberFormatException e){}
		catch(NullPointerException e){}

		try
		{
			aTracker.waitForAll();
		}
		catch(InterruptedException e)
		{
			return ;
		}
		loaded=true;
	}

	public void processStyle()
	{
		if(loaded==false)
			getStyle();
		if(loaded==false)
			return;
		if(processed==true)
			return;
		Graphics g;
		for(int i=0;i<Constant.BLOCK;i++)
		{
			this.block[i]=Constant.onlyFrame.createImage(Constant.blockW,Constant.blockH);
			g=this.block[i].getGraphics();
			g.drawImage(blocks,-i*Constant.blockW,0,Constant.onlyFrame);
		}

		for(int i=0;i<Constant.FACE;i++)
		{
			this.face[i]=Constant.onlyFrame.createImage(Constant.faceW,Constant.faceH);
			g=this.face[i].getGraphics();
			g.drawImage(faces,-i*Constant.faceW,0,Constant.onlyFrame);
		}

		for(int i=0;i<Constant.LED;i++)
		{
			this.led[i]=Constant.onlyFrame.createImage(Constant.LEDW,Constant.LEDH);
			g=this.led[i].getGraphics();
			g.drawImage(leds,-i*Constant.LEDW,0,Constant.onlyFrame);
		}
		processed=true;
	}
}