/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

#include "register.h"
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "recordFile.h"
#include "http.h"
#include "misc.h"

#define THE_BEST "theBest.ini"
#define BEST_TODAY "bestToday.ini"
#define LAST_WINNER "lastWinner.ini"

FILE *fpAll, *fpToday, *fpList;
static void record(FILE *fp, winnerData *client, winnerData *old);
void regist()
{
	int win=0, temp;
	winnerData client, old;
	byte currentPoint[4];

	if(argc!=4)
		showError("Wrong args in regist function.");
	if(fread(buffer, 16, 1, stdin)!=1)
		showError("Wrong client -- please do not try to hack the cgi, it is only a game, :)");
	if(strcmp(buffer, "\"IAMJMa v 1.1.x\""))
		showError("Wrong client -- please do not try to hack the cgi, it is only a game, :)");
	if(fread(buffer, blockSize, 1, stdin)!=1)
		showError("Wrong client -- please do not try to hack the cgi, it is only a game, :)");
	bytesToRecord(buffer, &client);
	touchRecord(&client);
	/* now I got the client's data  */

	/* below I want to record down the score */
	checkFiles();
	record(fpAll, &client, &old);
	record(fpToday, &client, &old);
	if(fread(currentPoint, 4, 1, fpList)!=1)
		showError("I/O error in regist function: fread.");
	temp=client.levelNtag%4;
	currentPoint[temp]=(currentPoint[temp]+1)%historyLength;
	writeRecord(fpList, 4, temp*historyLength+currentPoint[temp], &client);
	if(fseek(fpList, 0L, SEEK_SET))
		showError("I/O error in regist function: fseek.");
	if(fwrite(currentPoint, 4, 1, fpList)!=1)
		showError("I/O error in regist function: fwrite.");
	if(fclose(fpList))
		showError("I/O error in regist function: fclose.");
	puts("ok");
}

void checkFiles()
{
	winnerData tempRecord, tempRecord2;
	int i;

	tempRecord.levelNtag=255;
	touchRecord(&tempRecord);

	makeFilename(THE_BEST);
	if(!(fpAll=fopen(buffer, "rb+")))
	{
		if(!(fpAll=fopen(buffer, "wb+")))
			showError("I/O error in regist function:  fopen create.");
		for(i=0;i<8;i++)
		{
			if(writeRecord(fpAll, 0, i, &tempRecord))
				showError("I/O error in regist function: writeRecord.");
		}
	}

	makeFilename(BEST_TODAY);
	if(!(fpToday=fopen(buffer, "rb+")))
	{
		if(!(fpToday=fopen(buffer, "wb+")))
			showError("I/O error in regist function:  fopen create.");
		for(i=0;i<8;i++)
		{
			if(writeRecord(fpToday, 0, i, &tempRecord))
				showError("I/O error in regist function: writeRecord.");
		}
	}
	else
	{
		for(i=0;i<8;i++)
		{
			if(readRecord(fpToday, 0, i, &tempRecord2))
				showError("I/O error in regist function: writeRecord.");
			if(tempRecord.year!=tempRecord2.year || tempRecord.month!=tempRecord2.month
					|| tempRecord.day!=tempRecord2.day)
				if(writeRecord(fpToday, 0, i, &tempRecord))
					showError("I/O error in regist function: writeRecord.");
		}
	}

	makeFilename(LAST_WINNER);
	if(!(fpList=fopen(buffer, "rb+")))
	{
		byte tempBuffer[4];
		for(i=0;i<4;i++)
			tempBuffer[i]=0;
		if(!(fpList=fopen(buffer, "wb+")))
			showError("I/O error in regist function:  fopen create.");
		if(fwrite(tempBuffer, 4, 1, fpList)!=1)
			showError("I/O error in regist function: fwrite.");
		for(i=0;i<4*historyLength;i++)
		{
			if(writeRecord(fpList, 4, i, &tempRecord))
				showError("I/O error in regist function: writeRecord.");
		}
	}
	if(fseek(fpList, 0L, SEEK_SET))
		showError("I/O error in regist function: fseek.");
	if(fseek(fpAll, 0L, SEEK_SET))
		showError("I/O error in regist function: fseek.");
	if(fseek(fpToday, 0L, SEEK_SET))
		showError("I/O error in regist function: fseek.");
}

static void record(FILE *fp, winnerData *client, winnerData* old)
{
	if(readRecord(fp, 0, client->levelNtag, old))
		showError("I/O error in regist function: readRecord.");
	if(old->levelNtag==255 || old->score>client->score)
		if(writeRecord(fp, 0, client->levelNtag, client))
			showError("I/O error in regist function: writeRecord.");
	if(fclose(fp))
		showError("I/O error in regist function: fclose.");
}
